attribute highp vec4 Position;
attribute vec4 Offset;

attribute vec2 SourceColor;
varying vec2 DestinationColor;
uniform mat4 Projection;
uniform mat4 Modelview;

uniform float fScreenCenterX;
uniform float fScreenCenterY;
uniform float fLineWidth;
uniform float fAngle;  // 12 map rotate angle
uniform int iType;    // 13data type :    0: background 1:line 2: pointUUIDPointC 3:rotate along with map
uniform int IsTest;   //0: isn't test  1: is test

uniform float  vMapcenPointx;
uniform float  vMapcenPointy;
uniform int   IsRollUFO;
uniform int   IsRollDirection;
uniform float fUFOAngle;
uniform float fMapScale;
uniform float fLon_100M;
uniform float fLat_100M;
uniform float fSinMapAngle;
uniform float fCosMapAngle;
uniform float fHeadUpViewHeight;
uniform int   iCenEffectAccuracyX;
uniform int   iCenEffectAccuracyY;

uniform int   iUFOEffectAccuracyX;
uniform int   iUFOEffectAccuracyY;

void main(void) { // 4
    DestinationColor = SourceColor; // 5
    vec4 offset=Offset;
    vec4 position = Position;
    
    highp vec4 p1;
    offset.w = float(0);

    position.x = (position.x/1000.0 - float(vMapcenPointx) - float(iCenEffectAccuracyX)) / fLon_100M;
    position.y = (position.y/1000.0 - float(vMapcenPointy) - float(iCenEffectAccuracyY)) / fLat_100M;
        
    p1 = position;
    
    float x1 = p1.x * fCosMapAngle - p1.y * fSinMapAngle;
    float y1 = p1.x * fSinMapAngle + p1.y * fCosMapAngle;
    
    
    p1.x = x1;
    p1.y = y1;
    p1 += offset;
    
    gl_Position = Projection * (p1);
    
    
}